Index: xorg-server-7.2.0.0-1.5.99.1/config/dbus-core.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/config/dbus-core.c
+++ xorg-server-7.2.0.0-1.5.99.1/config/dbus-core.c
@@ -85,7 +85,7 @@ teardown(void)
      * completeness.  But then it gets awkward, given that you can't
      * guarantee that they'll be called ... */
     if (bus_info.connection)
-        dbus_connection_unref(bus_info.connection);
+        dbus_connection_close(bus_info.connection);
 
     RemoveBlockAndWakeupHandlers(block_handler, wakeup_handler, &bus_info);
     if (bus_info.fd != -1)
@@ -140,7 +140,7 @@ connect_to_bus(void)
     struct config_dbus_core_hook *hook;
 
     dbus_error_init(&error);
-    bus_info.connection = dbus_bus_get(DBUS_BUS_SYSTEM, &error);
+    bus_info.connection = dbus_bus_get_private(DBUS_BUS_SYSTEM, &error);
     if (!bus_info.connection || dbus_error_is_set(&error)) {
         DebugF("[config/dbus-core] error connecting to system bus: %s (%s)\n",
                error.name, error.message);
Index: xorg-server-7.2.0.0-1.5.99.1/configure.ac
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/configure.ac
+++ xorg-server-7.2.0.0-1.5.99.1/configure.ac
@@ -544,6 +544,7 @@ AC_ARG_ENABLE(dpms,           AS_HELP_ST
 AC_ARG_ENABLE(config-dbus,    AS_HELP_STRING([--enable-config-dbus], [Build D-BUS API support (default: no)]), [CONFIG_DBUS_API=$enableval], [CONFIG_DBUS_API=no])
 AC_ARG_ENABLE(config-hal,     AS_HELP_STRING([--disable-config-hal], [Build HAL support (default: auto)]), [CONFIG_HAL=$enableval], [CONFIG_HAL=auto])
 AC_ARG_ENABLE(xfree86-utils,     AS_HELP_STRING([--enable-xfree86-utils], [Build xfree86 DDX utilities (default: enabled)]), [XF86UTILS=$enableval], [XF86UTILS=yes])
+AC_ARG_ENABLE(avahi,   AS_HELP_STRING([--disable-avahi], [Build Avahi support (default: auto)]), [AVAHI=$enableval], [AVAHI=no])
 
 dnl DDXes.
 AC_ARG_ENABLE(xorg,    	      AS_HELP_STRING([--enable-xorg], [Build Xorg server (default: auto)]), [XORG=$enableval], [XORG=auto])
@@ -707,6 +708,12 @@ fi
 AM_CONDITIONAL(CONFIG_NEED_DBUS, [test "x$CONFIG_NEED_DBUS" = xyes])
 CONFIG_LIB='$(top_builddir)/config/libconfig.a'
 
+PKG_CHECK_MODULES(AVAHI, avahi-client, [HAVE_AVAHI=yes], [HAVE_AVAHI=no])
+if test "x$HAVE_AVAHI" = xyes; then
+        AC_DEFINE(HAVE_AVAHI, 1, [Have Avahi suppport])
+fi
+AM_CONDITIONAL(HAVE_AVAHI, [test "x$HAVE_AVAHI" = xyes])
+
 AC_MSG_CHECKING([for glibc...])
 AC_PREPROC_IFELSE([
 #include <features.h>
@@ -1565,8 +1572,7 @@ AM_CONDITIONAL(XQUARTZ, [test "x$XQUARTZ
 
 dnl DMX DDX
 
-PKG_CHECK_MODULES([DMXMODULES], [xmuu xext x11 xrender xfixes xfont xi dmxproto xau $XDMCP_MODULES], [have_dmx=yes], [have_dmx=no])
-AC_MSG_CHECKING([whether to build Xdmx DDX])
+PKG_CHECK_MODULES([DMXMODULES], [xmuu xext x11 xrender xfixes xfont xi >= 1.1.99.1 dmxproto xau xcomposite xrandr xv x11-xcb xcb-randr xcb-xinput xcb-aux >= 0.2.1 xcb-image xcb-shape $XDMCP_MODULES], [have_dmx=yes], [have_dmx=no])
 if test "x$DMX" = xauto; then
 	DMX="$have_dmx"
 	case $host_os in
@@ -1584,24 +1590,14 @@ if test "x$DMX" = xyes; then
 	fi
 	DMX_INCLUDES="$XEXT_INC $RENDER_INC $RECORD_INC"
 	XDMX_CFLAGS="$DMXMODULES_CFLAGS"
-	XDMX_LIBS="$XEXT_LIB $FB_LIB $CONFIG_LIB $RENDER_LIB $RECORD_LIB $XI_LIB $XKB_LIB $XKB_STUB_LIB $MIEXT_SHADOW_LIB $MIEXT_DAMAGE_LIB"
+	XDMX_LIBS="$DIX_LIB $CONFIG_LIB $COMPOSITE_LIB $FIXES_LIB $XEXT_LIB $FB_LIB $RENDER_LIB $RANDR_LIB $RECORD_LIB $DAMAGE_LIB $MIEXT_DAMAGE_LIB $MIEXT_SHADOW_LIB $XI_LIB $XKB_LIB $XKB_STUB_LIB $OS_LIB $MI_LIB"
 	XDMX_SYS_LIBS="$DMXMODULES_LIBS"
 	AC_SUBST([XDMX_CFLAGS])
 	AC_SUBST([XDMX_LIBS])
 	AC_SUBST([XDMX_SYS_LIBS])
-
-dnl USB sources in DMX require <linux/input.h>
-	AC_CHECK_HEADER([linux/input.h], DMX_BUILD_USB="yes",
-			DMX_BUILD_USB="no")
-dnl Linux sources in DMX require <linux/keyboard.h>
-	AC_CHECK_HEADER([linux/keyboard.h], DMX_BUILD_LNX="yes",
-			DMX_BUILD_LNX="no")
 	if test "x$GLX" = xyes; then
 		PKG_CHECK_MODULES([GL], [glproto])
 	fi
-	PKG_CHECK_MODULES([XDMXCONFIG_DEP], [xaw7 xmu xt xpm x11])
-	AC_SUBST(XDMXCONFIG_DEP_CFLAGS)
-	AC_SUBST(XDMXCONFIG_DEP_LIBS)
 	PKG_CHECK_MODULES([DMXEXAMPLES_DEP], [dmx xext x11])
 	AC_SUBST(DMXEXAMPLES_DEP_LIBS)
 	PKG_CHECK_MODULES([DMXXMUEXAMPLES_DEP], [dmx xmu xext x11])
@@ -1614,9 +1610,10 @@ dnl Linux sources in DMX require <linux/
 	AC_SUBST(XRESEXAMPLES_DEP_LIBS)
 	PKG_CHECK_MODULES([X11EXAMPLES_DEP], [xext x11])
 	AC_SUBST(X11EXAMPLES_DEP_LIBS)
+	PKG_CHECK_MODULES([DBUSEXAMPLES_DEP], [dbus-1 xcb])
+        AC_SUBST(DBUSEXAMPLES_DEP_CFLAGS)
+	AC_SUBST(DBUSEXAMPLES_DEP_LIBS)
 fi
-AM_CONDITIONAL([DMX_BUILD_LNX], [test "x$DMX_BUILD_LNX" = xyes])
-AM_CONDITIONAL([DMX_BUILD_USB], [test "x$DMX_BUILD_USB" = xyes])
 
 dnl kdrive DDX
 
@@ -1864,10 +1861,8 @@ hw/xfree86/xf8_16bpp/Makefile
 hw/xfree86/utils/Makefile
 hw/xfree86/utils/cvt/Makefile
 hw/xfree86/utils/gtf/Makefile
-hw/dmx/config/Makefile
 hw/dmx/doc/Makefile
 hw/dmx/examples/Makefile
-hw/dmx/input/Makefile
 hw/dmx/glxProxy/Makefile
 hw/dmx/Makefile
 hw/vfb/Makefile
Index: xorg-server-7.2.0.0-1.5.99.1/dix/events.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/dix/events.c
+++ xorg-server-7.2.0.0-1.5.99.1/dix/events.c
@@ -647,6 +647,7 @@ XineramaCheckVirtualMotion(
 static Bool
 XineramaCheckMotion(xEvent *xE, DeviceIntPtr pDev)
 {
+    INT16     *rootX, *rootY;
     WindowPtr prevSpriteWin;
     SpritePtr pSprite = pDev->spriteInfo->sprite;
 
@@ -654,15 +655,38 @@ XineramaCheckMotion(xEvent *xE, DeviceIn
 
     if (xE && !syncEvents.playingEvents)
     {
+	/* GetPointerEvents() guarantees that pointer events have the correct
+           rootX/Y set already. */
+        switch(xE->u.u.type)
+        {
+            case ButtonPress:
+            case ButtonRelease:
+            case MotionNotify:
+                rootX = &XE_KBPTR.rootX;
+                rootY = &XE_KBPTR.rootY;
+                break;
+            default:
+                if (xE->u.u.type == DeviceButtonPress ||
+		    xE->u.u.type == DeviceButtonRelease ||
+		    xE->u.u.type == DeviceMotionNotify)
+                {
+                    rootX = &((deviceKeyButtonPointer*)xE)->root_x;
+                    rootY = &((deviceKeyButtonPointer*)xE)->root_y;
+                    break;
+                }
+                /* all other events return FALSE */
+                return FALSE;
+        }
+
 	/* Motion events entering DIX get translated to Screen 0
 	   coordinates.  Replayed events have already been
 	   translated since they've entered DIX before */
-	XE_KBPTR.rootX += panoramiXdataPtr[pSprite->screen->myNum].x -
-			  panoramiXdataPtr[0].x;
-	XE_KBPTR.rootY += panoramiXdataPtr[pSprite->screen->myNum].y -
-			  panoramiXdataPtr[0].y;
-	pSprite->hot.x = XE_KBPTR.rootX;
-	pSprite->hot.y = XE_KBPTR.rootY;
+	*rootX += panoramiXdataPtr[pSprite->screen->myNum].x -
+	    panoramiXdataPtr[0].x;
+	*rootY += panoramiXdataPtr[pSprite->screen->myNum].y -
+	    panoramiXdataPtr[0].y;
+	pSprite->hot.x = *rootX;
+        pSprite->hot.y = *rootY;
 	if (pSprite->hot.x < pSprite->physLimits.x1)
 	    pSprite->hot.x = pSprite->physLimits.x1;
 	else if (pSprite->hot.x >= pSprite->physLimits.x2)
@@ -676,14 +700,14 @@ XineramaCheckMotion(xEvent *xE, DeviceIn
 	    ConfineToShape(pDev, pSprite->hotShape, &pSprite->hot.x, &pSprite->hot.y);
 
 	pSprite->hotPhys = pSprite->hot;
-	if ((pSprite->hotPhys.x != XE_KBPTR.rootX) ||
-	    (pSprite->hotPhys.y != XE_KBPTR.rootY))
+	if ((pSprite->hotPhys.x != *rootX) ||
+	    (pSprite->hotPhys.y != *rootY))
 	{
 	    XineramaSetCursorPosition(
 			pDev, pSprite->hotPhys.x, pSprite->hotPhys.y, FALSE);
 	}
-	XE_KBPTR.rootX = pSprite->hot.x;
-	XE_KBPTR.rootY = pSprite->hot.y;
+	*rootX = pSprite->hot.x;
+	*rootY = pSprite->hot.y;
     }
 
 #ifdef XEVIE
Index: xorg-server-7.2.0.0-1.5.99.1/dix/window.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/dix/window.c
+++ xorg-server-7.2.0.0-1.5.99.1/dix/window.c
@@ -2719,7 +2719,7 @@ EnableMapUnmapEvents(WindowPtr pWin)
     windowDisableMapUnmapEvents = NULL;
 }
 
-static Bool
+Bool
 MapUnmapEventsEnabled(WindowPtr pWin)
 {
     return pWin != windowDisableMapUnmapEvents;
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/Makefile.am
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/Makefile.am
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/Makefile.am
@@ -1,6 +1,6 @@
-DIST_SUBDIRS = input config glxProxy examples doc
+DIST_SUBDIRS = glxProxy examples doc
 
-SUBDIRS = input config examples
+SUBDIRS = examples
 bin_PROGRAMS = Xdmx
 
 if XINERAMA
@@ -20,11 +20,25 @@ if BUILDDOCS
 SUBDIRS += doc
 endif
 
+if CONFIG_DBUS_API
+DBUS_SRCS = dmxdbus.c dmxdbus.h
+DBUS_INCS = -I$(top_srcdir)/config
+DBUS_DEFS = @DBUS_CFLAGS@
+endif
+
+if HAVE_AVAHI
+AVAHI_SRCS = dmxavahi.c dmxavahi.h
+AVAHI_DEFS = @AVAHI_CFLAGS@
+endif
+
 AM_CFLAGS = \
       -DHAVE_DMX_CONFIG_H \
       $(DIX_CFLAGS) \
       $(GLX_INCS) \
       $(GLX_DEFS) \
+      $(DBUS_INCS) \
+      $(DBUS_DEFS) \
+      $(AVAHI_DEFS) \
       $(DMX_CFLAGS) \
       @DMXMODULES_CFLAGS@
 
@@ -62,8 +76,6 @@ Xdmx_SOURCES = dmx.c \
                dmxprop.h \
                dmxscrinit.c \
                dmxscrinit.h \
-               dmxshadow.c \
-               dmxshadow.h \
                dmxstat.c \
                dmxstat.h \
                dmxsync.c \
@@ -72,9 +84,29 @@ Xdmx_SOURCES = dmx.c \
                dmxvisual.h \
                dmxwindow.c \
                dmxwindow.h \
+               dmxatom.c \
+               dmxatom.h \
+               dmxlaunch.c \
+               dmxlaunch.h \
+               dmxshm.c \
+               dmxshm.h \
+               dmxcomp.c \
+               dmxcomp.h \
+               dmxrandr.c \
+               dmxrandr.h \
+               dmxxv.c \
+               dmxxv.h \
+               dmxgrab.c \
+               dmxgrab.h \
+               dmxselection.c \
+               dmxselection.h \
+               dmxdnd.c \
+               dmxdnd.h \
                $(top_srcdir)/mi/miinitext.c \
                $(top_srcdir)/fb/fbcmap_mi.c \
-               $(GLX_SRCS) 
+               $(GLX_SRCS) \
+               $(DBUS_SRCS) \
+               $(AVAHI_SRCS)
 
 
 #if COMPOSITE
@@ -84,9 +116,7 @@ Xdmx_SOURCES = dmx.c \
 XDMX_LIBS = \
 	@XDMX_LIBS@ \
 	$(GLX_LIBS) \
-        input/libdmxinput.a \
-        config/libdmxconfig.a \
-	$(XSERVER_LIBS)
+        $(AVAHI_LIBS)
 
 Xdmx_LDFLAGS = $(LD_EXPORT_SYMBOLS_FLAG)
 Xdmx_DEPENDENCIES= $(XDMX_LIBS)
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmx-config.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmx-config.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmx-config.h
@@ -74,15 +74,10 @@
 
 /* Disable the extensions that are not currently supported */
 #undef MULTIBUFFER
-#undef XV
 #undef DBE
 #undef XF86VIDMODE
 #undef XFreeXDGA
 #undef XF86DRI
 #undef SCREENSAVER
-#undef RANDR
-#undef XFIXES
-#undef DAMAGE
-#undef COMPOSITE
 
 #endif /* DMX_CONFIG_H */
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmx.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmx.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmx.c
@@ -63,10 +63,21 @@
 
 #ifdef PANORAMIX
 #include "panoramiX.h"
+extern unsigned long XRC_DRAWABLE;
 extern unsigned long XRT_WINDOW;
 extern int           PanoramiXNumScreens;
 #endif
 
+#ifdef RANDR
+#include "randrstr.h"
+#endif
+
+#include "dmxdbus.h"
+
+#ifdef HAVE_AVAHI
+#include "dmxavahi.h"
+#endif
+
 extern void DMXExtensionInit(void);
 
 static unsigned char DMXCode;
@@ -113,19 +124,41 @@ static int _DMXXineramaActive(void)
     return 0;
 }
 
+static void DMXResetProc(ExtensionEntry *extEntry)
+{
+
+#ifdef HAVE_AVAHI
+    dmx_avahi_fini ();
+#endif
+
+#ifdef CONFIG_DBUS_API
+    dmx_dbus_fini ();
+#endif
+
+}
+
 /** Initialize the extension. */
 void DMXExtensionInit(void)
 {
     ExtensionEntry *extEntry;
-    
+
     if ((extEntry = AddExtension(DMX_EXTENSION_NAME, 0, 0,
                                  ProcDMXDispatch, SProcDMXDispatch,
-                                 NULL, StandardMinorOpcode)))
+                                 DMXResetProc, StandardMinorOpcode)))
 	DMXCode = extEntry->base;
+
+#ifdef CONFIG_DBUS_API
+    dmx_dbus_init ();
+#endif
+
+#ifdef HAVE_AVAHI
+    dmx_avahi_init ();
+#endif
+
 }
 
 static void dmxSetScreenAttribute(int bit, DMXScreenAttributesPtr attr,
-                                  CARD32 value)
+				  CARD32 value)
 {
     switch (1 << bit) {
     case DMXScreenWindowWidth:   attr->screenWindowWidth   = value; break;
@@ -142,25 +175,25 @@ static void dmxSetScreenAttribute(int bi
 }
 
 static int dmxFetchScreenAttributes(unsigned int mask,
-                                    DMXScreenAttributesPtr attr,
-                                    CARD32 *value_list)
+				    DMXScreenAttributesPtr attr,
+				    CARD32 *value_list)
 {
     int    i;
     CARD32 *value = value_list;
     int    count  = 0;
-        
+
     for (i = 0; i < 32; i++) {
-        if (mask & (1 << i)) {
-            dmxSetScreenAttribute(i, attr, *value);
-            ++value;
-            ++count;
-        }
+	if (mask & (1 << i)) {
+	    dmxSetScreenAttribute(i, attr, *value);
+	    ++value;
+	    ++count;
+	}
     }
     return count;
 }
 
 static void dmxSetDesktopAttribute(int bit, DMXDesktopAttributesPtr attr,
-                                   CARD32 value)
+				   CARD32 value)
 {
     switch (1 << bit) {
     case DMXDesktopWidth:  attr->width  = value; break;
@@ -171,25 +204,25 @@ static void dmxSetDesktopAttribute(int b
 }
 
 static int dmxFetchDesktopAttributes(unsigned int mask,
-                                     DMXDesktopAttributesPtr attr,
-                                     CARD32 *value_list)
+				     DMXDesktopAttributesPtr attr,
+				     CARD32 *value_list)
 {
     int    i;
     CARD32 *value = value_list;
     int    count  = 0;
-        
+
     for (i = 0; i < 32; i++) {
-        if (mask & (1 << i)) {
-            dmxSetDesktopAttribute(i, attr, *value);
+	if (mask & (1 << i)) {
+	    dmxSetDesktopAttribute(i, attr, *value);
 	    ++value;
-            ++count;
-        }
+	    ++count;
+	}
     }
     return count;
 }
 
 static void dmxSetInputAttribute(int bit, DMXInputAttributesPtr attr,
-                                 CARD32 value)
+				 CARD32 value)
 {
     switch (1 << bit) {
     case DMXInputType:           attr->inputType      = value;   break;
@@ -199,19 +232,19 @@ static void dmxSetInputAttribute(int bit
 }
 
 static int dmxFetchInputAttributes(unsigned int mask,
-                                   DMXInputAttributesPtr attr,
-                                   CARD32 *value_list)
+				   DMXInputAttributesPtr attr,
+				   CARD32 *value_list)
 {
     int    i;
     CARD32 *value = value_list;
     int    count  = 0;
 
     for (i = 0; i < 32; i++) {
-        if (mask & (1 << i)) {
-            dmxSetInputAttribute(i, attr, *value);
-            ++value;
-            ++count;
-        }
+	if (mask & (1 << i)) {
+	    dmxSetInputAttribute(i, attr, *value);
+	    ++value;
+	    ++count;
+	}
     }
     return count;
 }
@@ -231,7 +264,7 @@ static int ProcDMXQueryVersion(ClientPtr
     rep.patchVersion   = DMX_EXTENSION_PATCH;
     if (client->swapped) {
     	swaps(&rep.sequenceNumber, n);
-        swapl(&rep.length, n);
+	swapl(&rep.length, n);
 	swapl(&rep.majorVersion, n);
 	swapl(&rep.minorVersion, n);
 	swapl(&rep.patchVersion, n);
@@ -254,9 +287,9 @@ static int ProcDMXSync(ClientPtr client)
     rep.length         = 0;
     rep.status         = 0;
     if (client->swapped) {
-        swaps(&rep.sequenceNumber, n);
-        swapl(&rep.length, n);
-        swapl(&rep.status, n);
+	swaps(&rep.sequenceNumber, n);
+	swapl(&rep.length, n);
+	swapl(&rep.status, n);
     }
     WriteToClient(client, sizeof(xDMXSyncReply), (char *)&rep);
     return client->noClientException;
@@ -273,27 +306,27 @@ static int ProcDMXForceWindowCreation(Cl
 
 #ifdef PANORAMIX
     if (!noPanoramiXExtension) {
-        PanoramiXRes *win;
-        int          i;
+	PanoramiXRes *win;
+	int          i;
 
-        if (!(win = SecurityLookupIDByType(client, stuff->window, XRT_WINDOW,
-                                           DixReadAccess)))
-            return -1;           /* BadWindow */
+	if (!(win = SecurityLookupIDByType(client, stuff->window, XRT_WINDOW,
+					   DixReadAccess)))
+	    return -1;           /* BadWindow */
 
-        FOR_NSCREENS(i) {
-            if (Success != dixLookupWindow(&pWin, win->info[i].id, client,
+	FOR_NSCREENS(i) {
+	    if (Success != dixLookupWindow(&pWin, win->info[i].id, client,
 					   DixReadAccess))
-                return -1;       /* BadWindow */
+		return -1;       /* BadWindow */
 
-            dmxForceWindowCreation(pWin);
-        }
-        goto doreply;
+	    dmxForceWindowCreation(pWin);
+	}
+	goto doreply;
     }
 #endif
 
     if (Success != dixLookupWindow(&pWin, stuff->window, client,
 				   DixReadAccess))
-        return -1;               /* BadWindow */
+	return -1;               /* BadWindow */
 
     dmxForceWindowCreation(pWin);
   doreply:
@@ -303,9 +336,9 @@ static int ProcDMXForceWindowCreation(Cl
     rep.length         = 0;
     rep.status         = 0;
     if (client->swapped) {
-        swaps(&rep.sequenceNumber, n);
-        swapl(&rep.length, n);
-        swapl(&rep.status, n);
+	swaps(&rep.sequenceNumber, n);
+	swapl(&rep.length, n);
+	swapl(&rep.status, n);
     }
     WriteToClient(client, sizeof(xDMXForceWindowCreationReply), (char *)&rep);
     return Success;
@@ -324,8 +357,8 @@ static int ProcDMXGetScreenCount(ClientP
     rep.screenCount    = dmxGetNumScreens();
     if (client->swapped) {
     	swaps(&rep.sequenceNumber, n);
-        swapl(&rep.length, n);
-        swapl(&rep.screenCount, n);
+	swapl(&rep.length, n);
+	swapl(&rep.screenCount, n);
     }
     WriteToClient(client, sizeof(xDMXGetScreenCountReply), (char *)&rep);
     return client->noClientException;
@@ -343,10 +376,10 @@ static int ProcDMXGetScreenAttributes(Cl
     REQUEST_SIZE_MATCH(xDMXGetScreenAttributesReq);
 
     if (stuff->physicalScreen < 0
-        || stuff->physicalScreen >= dmxGetNumScreens()) return BadValue;
+	|| stuff->physicalScreen >= dmxGetNumScreens()) return BadValue;
 
     if (!dmxGetScreenAttributes(stuff->physicalScreen, &attr))
-        return BadValue;
+	return BadValue;
 
     rep.logicalScreen       = attr.logicalScreen;
     rep.screenWindowWidth   = attr.screenWindowWidth;
@@ -359,7 +392,7 @@ static int ProcDMXGetScreenAttributes(Cl
     rep.rootWindowYoffset   = attr.rootWindowYoffset;
     rep.rootWindowXorigin   = attr.rootWindowXorigin;
     rep.rootWindowYorigin   = attr.rootWindowYorigin;
-                                 
+
     length                  = attr.displayName ? strlen(attr.displayName) : 0;
     paddedLength            = (length + 3) & ~3;
     rep.type                = X_Reply;
@@ -369,19 +402,19 @@ static int ProcDMXGetScreenAttributes(Cl
 
     if (client->swapped) {
     	swaps(&rep.sequenceNumber, n);
-        swapl(&rep.length, n);
-        swapl(&rep.displayNameLength, n);
-        swapl(&rep.logicalScreen, n);
-        swaps(&rep.screenWindowWidth, n);
-        swaps(&rep.screenWindowHeight, n);
-        swaps(&rep.screenWindowXoffset, n);
-        swaps(&rep.screenWindowYoffset, n);
-        swaps(&rep.rootWindowWidth, n);
-        swaps(&rep.rootWindowHeight, n);
-        swaps(&rep.rootWindowXoffset, n);
-        swaps(&rep.rootWindowYoffset, n);
-        swaps(&rep.rootWindowXorigin, n);
-        swaps(&rep.rootWindowYorigin, n);
+	swapl(&rep.length, n);
+	swapl(&rep.displayNameLength, n);
+	swapl(&rep.logicalScreen, n);
+	swaps(&rep.screenWindowWidth, n);
+	swaps(&rep.screenWindowHeight, n);
+	swaps(&rep.screenWindowXoffset, n);
+	swaps(&rep.screenWindowYoffset, n);
+	swaps(&rep.rootWindowWidth, n);
+	swaps(&rep.rootWindowHeight, n);
+	swaps(&rep.rootWindowXoffset, n);
+	swaps(&rep.rootWindowYoffset, n);
+	swaps(&rep.rootWindowXorigin, n);
+	swaps(&rep.rootWindowYorigin, n);
     }
     WriteToClient(client, sizeof(xDMXGetScreenAttributesReply), (char *)&rep);
     if (length) WriteToClient(client, length, (char *)attr.displayName);
@@ -403,12 +436,12 @@ static int ProcDMXChangeScreensAttribute
     int                              errorScreen = 0;
     unsigned int                     len;
     int                              ones = 0;
-    
+
 
     REQUEST_AT_LEAST_SIZE(xDMXChangeScreensAttributesReq);
     len = client->req_len - (sizeof(xDMXChangeScreensAttributesReq) >> 2);
     if (len < stuff->screenCount + stuff->maskCount)
-        return BadLength;
+	return BadLength;
 
     screen_list = (CARD32 *)(stuff + 1);
     mask_list   = &screen_list[stuff->screenCount];
@@ -416,28 +449,21 @@ static int ProcDMXChangeScreensAttribute
 
     for (i = 0; i < stuff->maskCount; i++) ones += Ones(mask_list[i]);
     if (len != stuff->screenCount + stuff->maskCount + ones)
-        return BadLength;
-    
+	return BadLength;
+
     if (!_DMXXineramaActive()) goto noxinerama;
 
     if (!(attribs = xalloc(stuff->screenCount * sizeof(*attribs))))
-        return BadAlloc;
+	return BadAlloc;
 
     for (i = 0; i < stuff->screenCount; i++) {
-        int count;
-        
-        if (i < stuff->maskCount) mask = mask_list[i];
-        dmxGetScreenAttributes(screen_list[i], &attribs[i]);
-        count = dmxFetchScreenAttributes(mask, &attribs[i], value_list);
-        value_list += count;
-    }
+	int count;
 
-#if PANORAMIX
-    status = dmxConfigureScreenWindows(stuff->screenCount,
-				       screen_list,
-				       attribs,
-				       &errorScreen);
-#endif
+	if (i < stuff->maskCount) mask = mask_list[i];
+	dmxGetScreenAttributes(screen_list[i], &attribs[i]);
+	count = dmxFetchScreenAttributes(mask, &attribs[i], value_list);
+	value_list += count;
+    }
 
     xfree(attribs);
 
@@ -450,14 +476,14 @@ static int ProcDMXChangeScreensAttribute
     rep.status         = status;
     rep.errorScreen    = errorScreen;
     if (client->swapped) {
-        swaps(&rep.sequenceNumber, n);
-        swapl(&rep.length, n);
-        swapl(&rep.status, n);
-        swapl(&rep.errorScreen, n);
+	swaps(&rep.sequenceNumber, n);
+	swapl(&rep.length, n);
+	swapl(&rep.status, n);
+	swapl(&rep.errorScreen, n);
     }
     WriteToClient(client,
-                  sizeof(xDMXChangeScreensAttributesReply),
-                  (char *)&rep);
+		  sizeof(xDMXChangeScreensAttributesReply),
+		  (char *)&rep);
     return client->noClientException;
 }
 
@@ -478,20 +504,25 @@ static int ProcDMXAddScreen(ClientPtr cl
     paddedLength = (stuff->displayNameLength + 3) & ~3;
     len          = client->req_len - (sizeof(xDMXAddScreenReq) >> 2);
     if (len != Ones(stuff->valueMask) + paddedLength/4)
-        return BadLength;
+	return BadLength;
 
     memset(&attr, 0, sizeof(attr));
-    dmxGetScreenAttributes(stuff->physicalScreen, &attr);
+    /*dmxGetScreenAttributes(stuff->physicalScreen, &attr); */
     value_list = (CARD32 *)(stuff + 1);
     count      = dmxFetchScreenAttributes(stuff->valueMask, &attr, value_list);
-    
+
     if (!(name = xalloc(stuff->displayNameLength + 1 + 4)))
-        return BadAlloc;
+	return BadAlloc;
     memcpy(name, &value_list[count], stuff->displayNameLength);
     name[stuff->displayNameLength] = '\0';
     attr.displayName = name;
+    
+    status = dmxAttachScreen(stuff->physicalScreen,
+			     &attr, 0, NULL, 0, NULL, 0, NULL,
+			     0, 0);
 
-    status = dmxAttachScreen(stuff->physicalScreen, &attr);
+    if (status == Success)
+	dmxEnableScreen(stuff->physicalScreen);
 
     xfree(name);
 
@@ -544,28 +575,32 @@ static int dmxPopulatePanoramiX(ClientPt
                                 CARD32 *screens, CARD32 *windows,
                                 xRectangle *pos, xRectangle *vis)
 {
-    WindowPtr              pWin;
-    PanoramiXRes           *win;
+    DrawablePtr            pDraw;
+    PanoramiXRes           *res;
     int                    i;
     int                    count = 0;
     DMXWindowAttributesRec attr;
     
-    if (!(win = SecurityLookupIDByType(client, window, XRT_WINDOW,
-                                       DixReadAccess)))
-        return -1;               /* BadWindow */
+
+    if(!(res = (PanoramiXRes *) SecurityLookupIDByClass(
+	     client, window, XRC_DRAWABLE, DixReadAccess)))
+	return -1;               /* BadDrawable */
     
     FOR_NSCREENS(i) {
-        if (Success != dixLookupWindow(&pWin, win->info[i].id, client,
-				       DixReadAccess))
-            return -1;          /* BadWindow */
-        if (dmxGetWindowAttributes(pWin, &attr)) {
-            screens[count] = attr.screen;
-            windows[count] = attr.window;
-            pos[count]     = attr.pos;
-            vis[count]     = attr.vis;
-            ++count;            /* Only count existing windows */
-        }
+	if (Success == dixLookupDrawable (&pDraw, res->info[i].id, client,
+					  M_ANY, DixUnknownAccess))
+	{
+	    if (dmxGetDrawableAttributes (pDraw, &attr))
+	    {
+		screens[count] = attr.screen;
+		windows[count] = attr.window;
+		pos[count]     = attr.pos;
+		vis[count]     = attr.vis;
+		++count;            /* Only count existing windows */
+	    }
+	}
     }
+
     return count;
 }
 #endif
@@ -573,7 +608,7 @@ static int dmxPopulatePanoramiX(ClientPt
 static int dmxPopulate(ClientPtr client, Window window, CARD32 *screens,
                        CARD32 *windows, xRectangle *pos, xRectangle *vis)
 {
-    WindowPtr              pWin;
+    DrawablePtr            pDraw;
     DMXWindowAttributesRec attr;
 
 #ifdef PANORAMIX
@@ -582,14 +617,21 @@ static int dmxPopulate(ClientPtr client,
                                     pos, vis);
 #endif
     
-    if (Success != dixLookupWindow(&pWin, window, client, DixReadAccess))
-        return -1;               /* BadWindow */
+    if (Success != dixLookupDrawable (&pDraw, window, client, 0,
+				      DixReadAccess))
+	return -1;
+
+    if (!dmxGetDrawableAttributes (pDraw, &attr))
+	return -1;
 
-    dmxGetWindowAttributes(pWin, &attr);
     *screens = attr.screen;
     *windows = attr.window;
     *pos     = attr.pos;
     *vis     = attr.vis;
+
+    if (!attr.window)
+	abort ();
+
     return 1;
 }
 
@@ -735,9 +777,6 @@ static int ProcDMXChangeDesktopAttribute
     dmxGetDesktopAttributes(&attr);
     dmxFetchDesktopAttributes(stuff->valueMask, &attr, value_list);
 
-#if PANORAMIX
-    status = dmxConfigureDesktop(&attr);
-#endif
     if (status == BadValue) return status;
 
   noxinerama:
